"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.printNpmReadme = void 0;
const core_1 = require("@semo/core");
const got_1 = __importDefault(require("got"));
const cheerio_1 = __importDefault(require("cheerio"));
const turndown_1 = __importDefault(require("turndown"));
const turndown_plugin_gfm_1 = require("turndown-plugin-gfm");
const marked_1 = __importDefault(require("marked"));
const marked_terminal_1 = __importDefault(require("marked-terminal"));
marked_1.default.setOptions({
    renderer: new marked_terminal_1.default()
});
exports.printNpmReadme = (input) => __awaiter(void 0, void 0, void 0, function* () {
    const url = `https://www.npmjs.com/package/${input}`;
    const response = yield got_1.default(url);
    console.log();
    const $ = cheerio_1.default.load(response.body);
    const body = $('body article').html();
    const turndownService = new turndown_1.default();
    turndownService.use(turndown_plugin_gfm_1.tables);
    if (body) {
        let converted = turndownService.turndown(body);
        converted = converted.replace(/\[\]\(\#.*?\)/g, '');
        core_1.Utils.consoleReader(marked_1.default(converted), {
            identifier: input,
            plugin: 'semo-plugin-repl-npm'
        });
    }
    else {
        console.log('Not found!');
    }
    return;
});
